SATNET.WebApp/Controllers/PackageController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using SATNET.WebApp.Attributes;
using SATNET.WebApp.Models;

namespace SATNET.WebApp.Controllers
{
    public class PackageController : BaseController
    {
        public PackageController()
        {

        }
        public async  Task<IActionResult> Index()
        {
            return View(GetPackagesList());
        }

        public async Task<IActionResult> Reset()
        {
            return Json(new { isValid = true, html = RenderViewToString(this, "Index", GetPackagesList()) });
        }
        public async Task<IActionResult> Add()
        {

            PackageModel packageModel = new PackageModel();
            packageModel.MenuModel = SetLayoutContent(heading: "Package", subHeading: "Add");

            return Json(new { isValid = true, html = RenderViewToString(this, "Add", packageModel) });
        }
        
        [HttpPost]
        public async Task<IActionResult> Add(PackageModel model)
        {
            
            //DistributorUserViewModel model = new DistributorUserViewModel();
            return Json(new { isValid = true, html = RenderViewToString(this, "Index", GetPackagesList()) });
        }
        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {

            PackageModel packageModel = new PackageModel { PackageId = 5, PackageName = "Text is there", Rate = 0 } ;
            packageModel.MenuModel = SetLayoutContent(heading: "Package", subHeading: "Edit");

            return Json(new { isValid = true, html = RenderViewToString(this, "Edit", packageModel) });
        }
        [HttpPost]
        public async Task<IActionResult> Edit(PackageModel model)
        {
            return Json(new { isValid = true, html = RenderViewToString(this, "Index", GetPackagesList()) });
        }

        [HttpGet]
        public async Task<IActionResult> Details(int id)
        {

            PackageModel packageModel = new PackageModel { PackageId = 5, PackageName = "Text is there", Rate = 0 };
            packageModel.MenuModel = SetLayoutContent(heading: "Package", subHeading: "Detail");

            return Json(new { isValid = true, html = RenderViewToString(this, "Details", packageModel) });
        }

        private PackageModelList GetPackagesList()
        {
            PackageModelList packageList = new PackageModelList();
            packageList.MenuModel = SetLayoutContent(heading: "Package",subHeading: "Listing");

            packageList.PackageModels.Add(new PackageModel { PackageId = 1, PackageName = "ABC", Rate = 1 });
            packageList.PackageModels.Add(new PackageModel { PackageId = 2, PackageName = "QWE", Rate = 2 });
            packageList.PackageModels.Add(new PackageModel { PackageId = 3, PackageName = "QWE", Rate = 3 });
            packageList.PackageModels.Add(new PackageModel { PackageId = 4, PackageName = "ZXC", Rate = 4 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "POI", Rate = 5 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "LKJ", Rate = 6 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "MNB", Rate = 7 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "BVC", Rate = 8 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "HGF", Rate = 9 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "TRE", Rate = 10 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "DSA", Rate = 11 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "JHG", Rate = 12 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "IUY", Rate = 13 });
            packageList.PackageModels.Add(new PackageModel { PackageName = "NBV", Rate = 14 });
            return packageList;
        }

        private MenuModel SetLayoutContent(string heading, string subHeading)
        {
            MenuModel model = new MenuModel
            {
                Heading = heading,
                SubHeading = subHeading
            };
            return model;
        }

    }
}

SATNET.WebApp/ViewComponents/ContentHeadViewComponent.cs
using Microsoft.AspNetCore.Mvc;
using SATNET.WebApp.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace SATNET.WebApp.ViewComponents
{
    [ViewComponent(Name = "ContentHead")]
    public class ContentHeadViewComponent : ViewComponent
    {
        public async Task<IViewComponentResult> InvokeAsync(MenuModel model)
        {
            
            return View("ContentHead", model);
        }
    }
}

SATNET.WebApp/Views/Package/Add.cshtml
@model SATNET.WebApp.Models.PackageModel
@*@{
        var controller = HttpContext.Current.Request.RequestContext.RouteData.Values["controller"].ToString();
    }*@

<!-- Main content -->
@await Component.InvokeAsync("ContentHead", @Model.MenuModel)

    <section class="content">
        <div class="card">
            <!-- /.card-header -->
            <div class="card-body">
                <form method="post" data-ajax="true" asp-controller="Package" asp-action="Add" data-ajax-method="post"
                      enctype="multipart/form-data" id="formAdd" autocomplete="off">
                    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                    <div class="card-body">
                        <div class="form-group row">
                            @Html.LabelFor(model => model.PackageName, new { @class = "col-sm-4 col-form-label" })
                            <div class="col-sm-8">
                                @Html.EditorFor(model => model.PackageName, new { htmlAttributes = new { @class = "form-control text-input", @placeholder = "Name" } })

                            </div>
                        </div>

                        <div class="form-group row">
                            @Html.LabelFor(model => model.PackageType, new { @class = "col-sm-4 col-form-label" })
                            <div class="col-sm-8">
                                @Html.DropDownListFor(model => model.PackageType, new SelectList(Model.PackageTypeList, "Value", "Text"), "-Select Paarent-", new { @class = "form-control select2 text-input" })


                            </div>
                        </div>

                        <div class="form-group row">
                            @Html.LabelFor(model => model.Rate, new { @class = "col-sm-4 col-form-label" })
                            <div class="col-sm-8">
                                @Html.EditorFor(model => model.Rate, new { htmlAttributes = new { @class = "form-control", @placeholder = "Password", @type = "password" } })
                            </div>
                        </div>
                    </div>
                    <!-- /.card-body -->

                    <div class="row">
                        <button type="submit" class="btn btn-primary btn-sm mr-3 pl-3 pr-3">Submit</button>
                        <a class="btn btn-default btn-sm pl-3 pr-3 right-pan" href="@String.Format("/{0}", "Package/Reset")">
                            Cancel
                        </a>
                    </div>
                </form>
            </div>
            <!-- /.card-body -->
        </div>
    </section>


<!-- /.Main content -->

<script language="javascript" type="text/javascript">
    $.validator.unobtrusive.parse('#formAdd');
    
</script>

SATNET.WebApp/Views/Package/Details.cshtml
@model SATNET.WebApp.Models.PackageModel
@*@{
        var controller = HttpContext.Current.Request.RequestContext.RouteData.Values["controller"].ToString();
    }*@

<!-- Main content -->
@await Component.InvokeAsync("ContentHead", @Model.MenuModel)

    <section class="content">
        <div class="card">
            <!-- /.card-header -->
            <div class="card-body">

                <div class="row">
                    <label class="col-sm-3">@Html.DisplayNameFor(model => model.PackageName):</label>
                    <div class="col-sm-9">
                        <span>@Html.DisplayFor(model => model.PackageName)</span>
                    </div>
                </div>
                <div class="row">
                    <label class="col-sm-3">@Html.DisplayNameFor(model => model.PackageType):</label>
                    <div class="col-sm-9">
                        <span>@Html.DisplayFor(model => model.PackageType)</span>
                    </div>
                </div>
                <div class="row">
                    <label class="col-sm-3">@Html.DisplayNameFor(model => model.Speed):</label>
                    <div class="col-sm-9">
                        <span>@Html.DisplayFor(model => model.Speed)</span>
                    </div>
                </div>
                <div class="row">
                    <label class="col-sm-3">@Html.DisplayNameFor(model => model.Rate):</label>
                    <div class="col-sm-9">
                        <span>@Html.DisplayFor(model => model.Rate)</span>
                    </div>
                </div>
                <div class="row">
                    <a class="btn btn-default btn-sm right-pan pl-3 pr-3 mt-3" href="@String.Format("/{0}", "Package/Reset")">
                        Back
                    </a>
                </div>
            </div>
            <!-- /.card-body -->
            
        </div>
    </section>


<!-- /.Main content -->

<script language="javascript" type="text/javascript">
    $.validator.unobtrusive.parse('#formAdd');
    
</script>

SATNET.WebApp/Views/Package/Edit.cshtml
@model SATNET.WebApp.Models.PackageModel
@*@{
        var controller = HttpContext.Current.Request.RequestContext.RouteData.Values["controller"].ToString();
    }*@

<!-- Main content -->
@await Component.InvokeAsync("ContentHead", @Model.MenuModel)

    <section class="content">
        <div class="card">
            <!-- /.card-header -->
            <div class="card-body">
                <form method="post" data-ajax="true" asp-controller="Package" asp-action="Edit" data-ajax-method="post"
                      enctype="multipart/form-data" id="formAdd" autocomplete="off">
                    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                    <div class="card-body">
                        <div class="form-group row">
                            @Html.LabelFor(model => model.PackageName, new { @class = "col-sm-4 col-form-label" })
                            <div class="col-sm-8">
                                @Html.EditorFor(model => model.PackageName, new { htmlAttributes = new { @class = "form-control text-input", @placeholder = "Name" } })

                            </div>
                        </div>

                        <div class="form-group row">
                            @Html.LabelFor(model => model.PackageType, new { @class = "col-sm-4 col-form-label" })
                            <div class="col-sm-8">
                                @Html.DropDownListFor(model => model.PackageType, new SelectList(Model.PackageTypeList, "Value", "Text"), "-Select Paarent-", new { @class = "form-control select2 text-input" })


                            </div>
                        </div>

                        <div class="form-group row">
                            @Html.LabelFor(model => model.Rate, new { @class = "col-sm-4 col-form-label" })
                            <div class="col-sm-8">
                                @Html.EditorFor(model => model.Rate, new { htmlAttributes = new { @class = "form-control", @placeholder = "Password", @type = "number" } })
                            </div>
                        </div>
                    </div>
                    <!-- /.card-body -->

                    <div class="row">
                        <button type="submit" class="btn btn-primary btn-sm mr-3 pl-3 pr-3">Submit</button>
                        <a class="btn btn-default btn-sm pl-3 pr-3 right-pan" href="@String.Format("/{0}", "Package/Reset")">
                            Cancel
                        </a>
                    </div>
                </form>
            </div>
            <!-- /.card-body -->
        </div>
    </section>


<!-- /.Main content -->

<script language="javascript" type="text/javascript">
    $.validator.unobtrusive.parse('#formAdd');
    
</script>

SATNET.WebApp/Views/Package/Index.cshtml
@model SATNET.WebApp.Models.PackageModelList


@await Component.InvokeAsync("ContentHead", @Model.MenuModel)

<!-- Main content -->

<section class="content">
    <div class="card">
        <!-- /.card-header -->
        <div class="card-body">
            <div class="row">
                <a class="btn btn-success right-pan pl-3 pr-3" href="@String.Format("/{0}", "Package/Add")">
                    <span class='fa fa-plus' aria-hidden='true'></span> &nbsp;Add
                </a>
            </div>
            <div id="BodyContent">
                @await Html.PartialAsync("_PackageList", Model)
            </div>
        </div>
        <!-- /.card-body -->
    </div>
</section>

<script type="text/javascript">

    $(function () {
        var t = $("#grid_table").DataTable({
            
            "paging": true,
            "lengthChange": true,
            "searching": true,
            "ordering": true,
            "info": true,
            "autoWidth": false,
            "responsive": true,
            "columnDefs": [
                { "orderable": false, "targets": 5 },
                { "orderable": false, "targets": 0 }
            ],
            //"columnDefs": [
            //    {
            //        'targets': 0, // column index (start from 0)bb
            //        'orderable': false, // set orderable false for selected columns
            //    }],
        });
        t.on('order.dt search.dt', function () {
            t.column(0, { search: 'applied', order: 'applied' }).nodes().each(function (cell, i) {
                cell.innerHTML = i + 1;
            });
        }).draw();
    });

</script>

SATNET.WebApp/Views/Package/_PackageList.cshtml
@model SATNET.WebApp.Models.PackageModelList

@{
    var controllerName = this.ViewContext.RouteData.Values["controller"].ToString();
}

<div class="dataTables_wrapper dt-bootstrap4 mt-2">
    <table id="grid_table" class="table table-bordered table-head-fixed text-nowrap dataTable " role="grid" aria-describedby="">
        <thead>
            <tr role="row">
                <th width="10%">Sr No</th>
                <th>
                    @Html.DisplayNameFor(model => model.PackageModels.FirstOrDefault().PackageName)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.PackageModels.FirstOrDefault().Rate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.PackageModels.FirstOrDefault().Speed)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.PackageModels.FirstOrDefault().PackageType)
                </th>
                <th>
                    Actions
                </th>
            </tr>
        </thead>
        <tbody>
            @{
                int counter = 0;
            }
            @foreach (var item in Model.PackageModels)
            {
                <tr role="row">
                    <td>
                        @{
                            counter++;
                        }
                        @counter
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.PackageName)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Rate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Speed)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.PackageType)
                    </td>
                    <td>
                        <a href="@String.Format("/{0}?id={1}", "Package/Edit", item.PackageId)" class="pl-1 pr-1 edit-pan">
                            <span class="fa fa-edit" aria-hidden="true"></span>
                        </a>
                        <a href="@String.Format("/{0}?id={1}", "Package/Details", item.PackageId)" class="pl-1 pr-1 right-pan">
                            <span class="fa fa-bars" aria-hidden="true"></span>
                        </a>
                        <a href="#" class="pl-1 pr-1">
                            <span class="fa fa-trash" aria-hidden="true"></span>
                        </a>
                    </td>
                </tr>
            }
        </tbody>

    </table>

</div>